<%
// ProjectConfig.jsp - 
// Copyright (C) 2003 Ecoo Team
// Miguel Valdes Faura
// valdes@loria.fr 
%>

<%@ page import="java.util.Vector, java.util.Iterator, java.util.Collection, hero.interfaces.BnUserLightValue, hero.interfaces.BnRoleValue, hero.interfaces.BnProjectPropertyValue, hero.interfaces.BnProjectHookValue, hero.interfaces.BnRoleLocal" %>
<%@ page language="java" %>
<%@ taglib uri="/WEB-INF/c.tld" prefix="c" %>
<%@ taglib uri="/WEB-INF/app.tld" prefix="app" %>
<%@ taglib uri="/WEB-INF/struts-bean.tld" prefix="bean" %>
<%@ taglib uri="/WEB-INF/struts-html.tld" prefix="html" %>
<%@ taglib uri="/WEB-INF/struts-logic.tld" prefix="logic" %>
<%@ taglib uri="/WEB-INF/struts-layout.tld" prefix="layout" %>

<jsp:useBean id="project" scope="session" class="hero.interfaces.ProjectSessionLocal"/>

<% 

    pageContext.setAttribute("hooks", new Vector(project.getHooks()));
    pageContext.setAttribute("properties", new Vector(project.getProperties()));
    pageContext.setAttribute("interHooks", new Vector(project.getInterHooks()));
    Collection users = project.getUsers();
    Iterator iusers = users.iterator();

    Vector usersP = new Vector();
    Vector rolesP = new Vector();
    int i,j;

    while(iusers.hasNext())
    {
      String actualUser = (String)iusers.next();
      Collection uRoles = project.getUserRoles(actualUser);
      Collection pRoles = project.getRoles();

      Iterator iuroles = uRoles.iterator();
      while(iuroles.hasNext())
      {
         BnRoleLocal actualuRole = (BnRoleLocal)iuroles.next();
         Iterator iproles = pRoles.iterator();
         while(iproles.hasNext())
         {
           BnRoleLocal actualpRole = (BnRoleLocal)iproles.next();
           if (actualuRole.getId() == actualpRole.getId())
           {
             usersP.add(actualUser);
             rolesP.add(actualuRole.getName());
           }
         }
      } 

    } 
    pageContext.setAttribute("usersP", usersP);
    pageContext.setAttribute("rolesP", rolesP);

    Vector events = new Vector();
    events.add("beforeStart");
    events.add("afterStart");
    events.add("beforeTerminate");
    events.add("afterTerminate");
    events.add("anticipate");
    events.add("onCancel");
    pageContext.setAttribute("events", events);
    
    Vector types = new Vector();
    types.add("Java");
    types.add("Tcl");
    types.add("BeanShell");
    pageContext.setAttribute("types", types);

    Vector types2 = new Vector();
    types2.add("InteractionBS");
    pageContext.setAttribute("types2", types2);   

%>

<table width="982" border="0" cellpadding="0">
   <td><b><I><bean:write name="project" property="name"/></I> <bean:message key="project.projectname"/> <bean:write name="project" property="creator"/><bean:message key="bonita.configprojectpage"/></b></td>
   <%
      String username = (pageContext.getSession()).getAttribute("username").toString();
   %>
   <td align="right"><font color="#009900"><I><%=username%></I></font></td>
</table>

<hr align="left" width="982" color="#993366" size="5"</hr>


<table cellpadding="2" cellspacing="2" border="0" width="982" align="left" class="viewer">
<tr valign="Top">

<td valign="left" width="300">
<H4><u><bean:message key="project.allproperties"/></u></H4>

<% if (((Vector)pageContext.findAttribute("properties")).size() == 0) {%>
<bean:message key="properties.notexist"/>
<%}else{%>

<table class="viewer">
   <tr bgcolor="#3333CC">
      <td><b class="projet">Name</b>
      </td>
      <td><b class="projet">Value</b>
      </td>
      <td align="center"><b class="projet">Action</b>
      </td>
   </tr>
   <c:forEach items="${properties}" var="prop">
      <tr>
         <td>
         <c:out value="${prop.theKey}"/>
         </td>
         <td>
        <c:out value="${prop.theValue}"/>
         </td>
         <td><table><td>
         <a href="property.action?propertyAction=Delete&key=<c:out value="${prop.theKey}"/>"  onclick="return confirm('Really delete file?');" class="viewer">remove</a>
         </td>
         <td>
         <a href="property.action?propertyAction=EditProjectProp&key=<c:out value="${prop.theKey}"/>&value=<c:out value="${prop.theValue}"/>" class="viewer">edit</a>
         </td></table></td>
      </tr>
   </c:forEach>
</table>
<%}%>

<br>
</td>
<td valign="left" width="350">
<H4><u><bean:message key="project.allhooks"/></u></H4>

<% if (((Collection)pageContext.findAttribute("interHooks")).size() == 0) {%>
<bean:message key="hooks.notexist"/>
<%}else{%>
<table class="viewer">
   <tr bgcolor="#3333CC">
      <td><b class="projet">Name</b>
      </td>
      <td><b class="projet">Event</b>
      </td>
      <td><b class="projet">Type</b>
      </td>
      <td><b class="projet">Script</b>
      </td>
      <td width="100"><b class="projet">Action</b>
      </td>
   </tr>
   <c:forEach items="${interHooks}" var="ho">
      <tr>
         <td>
         <c:out value="${ho.name}"/>
         </td>
         <td>
        <c:out value="${ho.event}"/>
         </td>
         <td>
         <c:out value="${ho.type}"/>
         </td>
         <td>
         <c:out value="${ho.script}"/>
         </td> 
	 <td><table><tr><td>
         <a href="hook.action?hookAction=Delete&name=<c:out value="${ho.name}"/>"  onclick="return confirm('Really delete file?');" class="viewer">remove</a>
         </td>
	 <td>
         <a href="hook.action?hookAction=editProjectScript&name=<c:out value="${ho.name}"/>" class="viewer">edit</a>
         </td></tr></table></td>
      </tr>
   </c:forEach><tr>
</table>
<%}%>

<br>
</td></tr>
<br><br>
<tr valign="Top" align="left">
<td valign="left" width="400">
<H4><u><bean:message key="project.allusers"/><u></H4>
<table class="viewer" width="500">
   <tr bgcolor="#3333CC">
      <td><b class="projet">User</b>
      </td>
      <td><b class="projet">Role</b>
      </td>
   </tr>
   <!--Variable servant a grer la multicollection-->
   <c:set var="nbid" value="0" scope="page"/>
   <c:forEach items="${usersP}" var="us">
   
      <tr>
         <td>
         <c:out value="${us}"/>
         </td>
         <c:forEach items="${rolesP}" var="rol" begin="${nbid}" end="${nbid}">
            <td>
               <c:out value="${rol}"/>
               <c:set var="nbid" value="${nbid+1}" scope="page"/>
            </td>
         </c:forEach>
      </tr>
   </c:forEach>
</table>

<a href="project.action?action=viewproject" style="text-decoration: none;" class="viewer"><bean:message key="project.viewmode"/></a>
</td>
<td valign="Top" align="left" width="400">
<br>
<br>
<layout:html locale="true" key="project.action" styleClass="FORM">

<% if ((pageContext.getRequest()).getParameter("propertyAction") != null && (((pageContext.getRequest()).getParameter("propertyAction")).equals("Edit") || ((pageContext.getRequest()).getParameter("propertyAction")).equals("EditProjectProp")) ) {%> 
<c:choose>
<c:when test="${projectProp==1}">
<Form method="POST" action="/bonita/protected/property.action?propertyAction=Add" class="FORM">
<table><tr><td>key : </td><td><input type="text" name="key" value="<c:out value="${ProjectProp.key}"/>"readonly></td></tr>
<tr><td>value : </td><td><input type="text" name="value" value="<c:out value="${ProjectProp.value}"/>"></td></tr>
<tr><td><input type="submit" value="submit"></td></tr></table>
</Form>
</c:when>
<c:otherwise>
<Form method="POST" action="/bonita/protected/property.action?propertyAction=Add" class="FORM">
<table><tr><td>key : </td><td><input type="text" name="key" value=""</td></tr>
<tr><td>value : </td><td><input type="text" name="value" value=""></td></tr>
<tr><td><input type="submit" value="submit"></td></tr></table>
</Form>
</c:otherwise>
</c:choose>

 <%}else if ((pageContext.getRequest()).getParameter("hookAction") != null && ((pageContext.getRequest()).getParameter("hookAction")).equals("Edit2"))
   {
%> <layout:form action="/protected/hook.action?hookAction=Add2" focus="name" styleClass="FORM" key="hook" align="center">

  <layout:text key="prompt.hookName" property="name" size="20" maxlength="30" styleClass="LABEL" mode="E,E,E"/>

   <layout:select key="prompt.event" property="event" styleClass="LABEL">
        <layout:options collection="events"/>
   </layout:select>

   <layout:select key="prompt.type" property="type" styleClass="LABEL">
        <layout:options collection="types2"/>
   </layout:select>

  <layout:formActions>
      <layout:submit property="submit" value="Submit"/>
      <layout:cancel/>
  </layout:formActions>

 </layout:form>

<%}else if ((pageContext.getRequest()).getParameter("hookAction") != null && (pageContext.findAttribute("inter")).equals("true"))
   {
%> <layout:form action="/protected/hook.action?hookAction=AddHook" focus="name" styleClass="FORM" key="hook" align="center">

  <layout:textarea key="prompt.script" property="value" styleClass="LABEL" mode="E,E,E" rows="10" size="40" maxlength="50"/>

  <layout:formActions>
      <layout:submit property="submit" value="Submit"/>
      <layout:cancel/>
  </layout:formActions>

 </layout:form>

<%}else if ((pageContext.getRequest()).getParameter("hookAction") != null && (pageContext.getRequest()).getParameter("hookAction").equals("editProjectScript"))
   {
%> 
<Form method="POST" action="/bonita/protected/hook.action?hookAction=addEditProjectScript" class="FORM">
<table>
<tr><td>script :</td><td><textarea type="textarea" rows="15" name="value" cols="40"><c:out value="${scri}"/></textarea></td></tr>
<tr><td><input type="submit" value="submit"></td></tr></table>
</Form> 


<%}else{%>

<table cellpadding="2" cellspacing="2" border="0" align="center">
<tbody>
<tr valign="Top">
<td valign="Top" width="135" align="Center"><a href="property.action?propertyAction=Edit" style="text-decoration: none;" class="viewer"><bean:message key="property.add"/></a><br>
</td>

<td valign="Top" width="130" align="Center"><a href="hook.action?hookAction=Edit2" style="text-decoration: none;" class="viewer"><bean:message key="hookInter.add"/></a><br>
</td>
</tr>
</tbody>
</table>

<html:errors property="property_error"/>
<html:errors property="hook_error"/>
<%}%>

</layout:html>

</td></tr>
</tbody>
</table>
