package hero.mapper;

import hero.util.HeroException;
import hero.interfaces.BnRoleLocal;

// use of the ProjectSession Bean
import hero.interfaces.ProjectSessionLocalHome;
import hero.interfaces.ProjectSessionLocal;
import hero.interfaces.ProjectSessionUtil;

import java.util.*;


public class CustomGroupMembers implements hero.mapper.RoleMapperI {

    public void searchMembers(Object b,BnRoleLocal n, String userName) throws HeroException {
    		
	    String roleName=n.getName();
	    String projectName=n.getBnProject().getName();
	    
	    // logs trace	    
	    System.out.println("[CustomGroupMembers] BnRole name:"+roleName + " - Project name = " + projectName);
	    System.out.println("[CustomGroupMembers] Not implemented ..... ");
		try {

			ProjectSessionLocalHome projecth = (ProjectSessionLocalHome)ProjectSessionUtil.getLocalHome();
			ProjectSessionLocal projectsession = projecth.create();
			projectsession.initProject(projectName);
			
			// Template to be completed / implemented ......								
			// add user to the project  instance (but not for the project model)
			projectsession.addUser("userName");
								
			// set the user role
			projectsession.setUserRole("userName", roleName);
						
			projectsession.remove();
		
		} catch (Exception e) {		    
			throw new HeroException("Error setting role : " + roleName + " with mapper " + e.getMessage());
		}				    
    } 

}















