package hero.performerAssign;

import hero.util.HeroException;
import hero.interfaces.BnNodeLocal;

// use of the ProjectSession Bean
import hero.interfaces.ProjectSessionLocalHome;
import hero.interfaces.ProjectSessionLocal;
import hero.interfaces.ProjectSessionUtil;

import hero.interfaces.BnRoleLocalHome;
import hero.interfaces.BnRoleLocal;
import hero.interfaces.BnRoleUtil;

import hero.interfaces.BnUserLocal;

import javax.ejb.FinderException;
import javax.ejb.RemoveException;

import java.util.*;

public class CallbackSelectActors implements hero.performerAssign.NodePerformerAssignI {

    public void selectActors(Object b,BnNodeLocal n, String userName) throws HeroException {   		
	    String nodeName=n.getName();
	    String projectName=n.getBnProject().getName();
	    int projectId = n.getBnProject().getId();
	    String roleName ="";
	    //ProjectSessionLocal projectsession = null;
	    
	    // logs trace	    
	    System.out.println("[CallbackSelectActors] BnNode name:"+nodeName + " - Project name = " + projectName);
	    System.out.println("[CallbackSelectActors] Just a template to be completed ..... ");
		try {
			/* 
			ProjectSessionLocalHome projecth = (ProjectSessionLocalHome)ProjectSessionUtil.getLocalHome();
			projectsession = projecth.create();
			projectsession.initProject(projectName);
			*/
			
			roleName = n.getBnRole().getName();
			// logs trace
			System.out.println("[CallbackSelectActors] execution for node: " + nodeName + " role: " + roleName + " project id: " + projectId);
		}catch(Exception e){
			throw new HeroException(e.getMessage());
		}
			
			BnRoleLocalHome roleh;
			
			// Example to get users for the role/node
			// Then you must choose according your process and your SI. 
			try {
				 roleh = BnRoleUtil.getLocalHome();
			} catch (javax.naming.NamingException ne) {
				throw new HeroException(ne.getMessage());
			}
			BnRoleLocal role = null;
			try {
				 role = roleh.findByName(roleName, projectId);
				} catch (FinderException pfe) {
				  throw new HeroException("[CallbackSelectActors] The bnRole does not exist for role : " + roleName);
				}
			Collection ar = null;
			
			try {
			ar = role.getBnUsers();
			Iterator it = ar.iterator();
			boolean fl =true;
			while (it.hasNext()) {
				BnUserLocal userL = (BnUserLocal)it.next();
				String user = userL.getName();
				if (fl) {
					// choose the first of the list and save it to the activityPerformer of BnNodeBean
					try{
						n.setActivityPerformer(user);
					} catch (Exception e){
					e.printStackTrace();
					throw new HeroException("[CallbackSelectActors]Error setting activity performer " + e.getMessage());
					}		
				fl=false;				
				}

				// logs trace
				System.out.println("user = " + user);
			}
			}catch (Exception e){
				throw new HeroException("[CallbackSelectActors]" + e.getMessage());
			}
/*					
		try {				
			projectsession.remove();
		
		} catch (RemoveException e){
			throw new HeroException("[CallbackSelectActors]Error removing bean in CallbackSelectActors " + e.getMessage());
		}	
*/
    } 
}















